---
title: 'XRSession: inputsourceschange event'
slug: Web/API/XRSession/inputsourceschange_event
tags:
  - API
  - AR
  - Input Sources
  - Inputs
  - Mixed
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSources
  - XRSession
  - augmented
  - events
  - inputsourceschange
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_Header}}</p>

<p><span class="seoSummary">The <strong><code>inputsourceschange</code></strong> event is sent to an {{domxref("XRSession")}} when the set of available WebXR input devices changes.</span> The received event, of type {{domxref("XRInputSourcesChangeEvent")}}, contains a list of any newly {{domxref("XRInputSourcesChangeEvent.added", "added")}} and/or {{domxref("XRInputSourcesChangeEvent.removed", "removed")}} input devices.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("XRInputSourcesChangeEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("XRSession.oninputsourceschange", "oninputsourceschange")}}</td>
  </tr>
 </tbody>
</table>

<p>The event object contains lists of the newly-added and/or removed input devices in its {{domxref("XRInputSourcesChangeEvent.added", "added")}} and {{domxref("XRInputSourcesChangeEvent.removed", "removed")}} properties.</p>

<h2 id="Examples">Examples</h2>

<p>{{page("/en-US/docs/Web/API/XRInputSourcesChangeEvent", "Example")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#eventdef-xrsession-inputsourceschange","inputsourceschange event")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSession.inputsourceschange_event")}}</div>
